
module M {
  public Main () : void {
    print_endline ("Testing the assertions...");
    
    mutable i <- 10;
    
    try
      assert (i == 10)    
    with { _ : Assertion_failed => 
      print_endline ("Assertion number 1 failed") };

    i <- 20;

    try
      assert (i == 20)
    with { _ : Assertion_failed => 
      print_endline ("Assertion number 2 failed") };

    try
      assert (i == 19) 
    with { 
      | _ : Assertion_failed => 
        print_endline ("Assertion number 3 failed") 
      | _ : System.Exception =>
        print_endline ("Got System.Exception (wrong!)") 
    };
    
    try
      assert (i == 19) 
    with { 
      | _ : System.Exception =>
        print_endline ("Got System.Exception (ok!)") 
      | _ : Assertion_failed => 
        print_endline ("Assertion number 3 failed (wrong!)") 
    };
    
  }
}

/*
BEGIN-OUTPUT
Testing the assertions...
Assertion number 3 failed
Got System.Exception (ok!)
END-OUTPUT
*/
