(** this is test program for accesing sql databse
    as for now it requires Postgres database server running on localhost
    with database user 'postgres' (password 'sql')
 *)

open System;
open System.Data;
open Npgsql;
 
public class Test 
 {
    public static Main() : void
    {
       Console.WriteLine("start...");

       def connectionString = 
          "Server=localhost;" +
          "Database=test;" +
          "User ID=postgres;" +
          "Password=sql;";

       def dbcon = Npgsql.NpgsqlConnection (connectionString);
       dbcon.Open();
       Console.WriteLine("connection opened...");

       // requires a table to be created named employee
       // with columns firstname and lastname
       // such as,
       //        CREATE TABLE employee (
       //           firstname varchar(32),
       //           lastname varchar(32));
       def sql = "SELECT firstname, lastname " +
           "FROM employee WHERE firstname = :a";
       def dbcmd = NpgsqlCommand (sql, dbcon);
       (dbcmd.Parameters.Add (NpgsqlParameter ("a", DbType.String))).Value <- "Kasia";
//       dbcmd.Parameters.Add("a", "Kasia");
       Console.WriteLine("query constructed...");

       def reader = dbcmd.ExecuteReader();
       Console.WriteLine("query executed...");

       while(reader.Read()) {
            def FirstName = (reader["firstname"] :> string);
            def LastName = (reader["lastname"] :> string);
            Console.WriteLine("Name: " + FirstName + " " + LastName);
       };
       Console.WriteLine("output written...");

       // clean up
       reader.Close();
       dbcmd.Dispose();
       dbcon.Close();
    }
 }
